{-

SPS/APS - Security Protocol Specification langauge
Copyright Omar Saad Almousa, Technical Univerity of Denmark (DTU) 2013-2015

All Rights Reserved.

-}
module ToFormat where
import Data.List
---------------------------------------------------------
formClasses [] = error("This protocol has no Formats")
formClasses [a] = [oneClass a]
formClasses (x:y:z) = oneClass x : formClasses (y:z)
--------------------------------------------------------- 
oneClass (name,fieldTypes)= "//Auto-generated by APS\n//Format class prototype\n public class "++name++"{"++(fields n n) ++  constructors name n
                            where n= length fieldTypes
---------------------------------------------------------
fields  0 n = "" -- error("A format without fields, how comes?")
fields  1 n = "\n\t private byte[] field1;" 
fields  m n = fields (m-1) n ++ "\n\t private byte[] field" ++show(m)++";" 
---------------------------------------------------------
constructors name n = "\t public "++ name ++"( byte [] input){//insert your format parser code \n\t}\n" ++
                        "\t public "++ name ++"(" ++ bytes n++")"++"{//insert your format setter here\n"++ setters n ++"\t}\n"++
                        getters n ++ "public byte[] encode()"++"{//insert your format pretty-printer code here \n\t\t}\n"++
						"public verify(){\n\t//insert your verifier code here\n\t}}\n\n\n"
---------------------------------------------------------
bytes 1 = "byte[] x1"
bytes 2 = "byte[] x1, byte[] x2"
bytes n =  bytes (n-1)++", byte[] x"++show(n) 
---------------------------------------------------------
getters 0=""
getters n= getters (n-1)++ "\n\t public byte[] get"++show(n)++"(){\n\t //insert your getter code here\n\t return field"++show(n)++";\n\t}\n" 
---------------------------------------------------------
setters 0 = ""
setters n = setters (n-1)++ "\t\t field"++show(n)++"=x"++show(n) ++";\n"